//
// Created by nov11 on 23.12.2021.
//

#include <iostream>
#include "menu.h"

#define PC_DEBUG_MODE

menu_t* menu_t::add_option(menu_option_t* option) {
    if(option != nullptr)
        options.push_back(option);

    return this;
}

void menu_t::render() {
    for(auto& option : options)
        option->render();

    // Ask for action
#ifdef PC_DEBUG_MODE
    int num;

    std::cout << "Please select an option:" << std::endl;
    std::cin >> num;

    execute_option(num - 1, ON_PRESS);
#endif
}

void menu_t::execute_option(int i, action_type_t actionType) {
    if(i < options.size())
        options[i]->execute(actionType);
}
