//
// Created by nov11 on 23.12.2021.
//

#ifndef MENULIB_MENU_COMMON_H
#define MENULIB_MENU_COMMON_H

#include <stack>
#include "menu.h"
#include "menu_option.h"
#include "action.h"
#include "actions/submenu_action_t.h"
#include "actions/submenu_back_action_t.h"

#define MENU_SUBMENU_OPTION(title, submenu) (new menu_option_t(title))->add_listener((action_t*) submenu)
#define MENU_SIMPLE_OPTION(title, listener, type) (new menu_option_t(title))->add_listener(new action_t(listener, type))
#define MENU_BACK_OPTION(title) (new menu_option_t(title))->add_listener((action_t*) new submenu_back_action_t()))

class menu_common_t {

private:
    static inline std::vector<menu_t*> path{}; // Represents current menu path

public:
    static void open_menu(menu_t* menu);
    static void go_back(int amount = 1);

};


#endif //MENULIB_MENU_COMMON_H
